#include <TROOT.h>
#include <TApplication.h>
#include <TCanvas.h>
#include <TSystem.h>
#include <Riostream.h>
//#include <Reflex/Reflex.h>
#include <stdlib.h>
#include <stdio.h>

#include "HepMC/SimpleVector.h"
#include "../HepMCVisual/HepMCVisualElements.h"

using namespace HepMC;

//  class My_Visual {
//    public:
//      bool operator() ( GenVertex* invertex );
//  };
//
//  Bool_t My_Visual::operator()( HepMC::GenVertex* invertex ){
//    
//    //Sanitiy check
//    if (!invertex) return kFALSE;
//    
//    using namespace ROOT::Reflex;
//
//    //Check if vertex is visual
//    if ( Type::ByTypeInfo(typeid(*invertex)) == VisVertexType )
//      return kTRUE;
//    else return kFALSE;
//  }
//
int main( int argc, char** argv ){

   TApplication theApp("App", &argc, argv);
 
   if (gROOT->IsBatch()) {
      fprintf(stderr, "%s: cannot run in batch mode\n", argv[0]);
      return 1;
   }
 
   TCanvas* chepmc = new TCanvas("chepmc","HepMCVisual Demo",900,600);
 
 

//   using namespace ROOT::Reflex ;
//   cout << "ThisVertex:\t" << Type::ByTypeInfo(typeid(*v0)).Name(SCOPED) << endl;
//   cout << "VisVertex:\t" << VisVertexType.Name(SCOPED) << endl;

//   cout << "ByTypeInfo:";
//   if ( Type::ByTypeInfo(typeid(*v0)) == VisVertexType )
//    cout << "\tyes" << endl;
//   else
//     cout << "\tno" << endl;

//   cout << "ByTypeName:";
//   if ( Type::ByTypeInfo(typeid(*v0)) == Type::ByName("HepMC::VisualVertex") )
//     cout << "\tyes" << endl;
//   else
//     cout << "\tno" << endl;
//
//   cout << "IsVisual:";
//   if ( IsVisual(v0))
//     cout << "\tyes" << endl;
//   else
//     cout << "\tno" << endl;
//   
//
//   cout << "MyVisual:";
//   My_Visual myVisual;
//   if ( myVisual(v0))
//     cout << "\tyes" << endl;
//   else
//     cout << "\tno" << endl;
//

   //Two particles in a row
   VisualVertex   * v0 = new VisualVertex(.25,.5);

   GenVertex   * v1 = new GenVertex();
   GenVertex   * v2 = new GenVertex();
   GenVertex   * v3 = new GenVertex();
   GenParticle * p1 = new GenParticle(FourVector(0,0,0,0),24);
   GenParticle * p2 = new GenParticle(FourVector(0,0,0,0),11);
   GenParticle * p3 = new GenParticle(FourVector(0,0,0,0),-11);

   v0->add_particle_out(p1);
   v1->add_particle_in(p1);
   v1->add_particle_out(p2); v2->add_particle_in(p2);
   v1->add_particle_out(p3); v3->add_particle_in(p3);
  // p1->SetShow(); p2->SetShow(); p3->SetShow();

   GenEvent* evt = new GenEvent(1,0,0);
   evt->add_vertex(v0);
   evt->add_vertex(v1);
   evt->add_vertex(v2);
   evt->add_vertex(v3);
   evt->set_signal_process_vertex(v1);
   Visualize(evt)->Draw();

   theApp.Run();
 
   return 0;
}
